package ru.alphatech.icfpc.game.strategy;

import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.LinkedList;
import java.util.Queue;

import ru.alphatech.icfpc.game.Batch;
import ru.alphatech.icfpc.game.Player;
import ru.alphatech.icfpc.game.Value;
import ru.alphatech.icfpc.policy.AttackHelpPolicy;
import ru.alphatech.icfpc.policy.CallExpressionPolicy;

/**
 * @author indvdum
 * 20.06.2011 1:59:59
 *
 */
public class YetAnotherStrategy implements IStrategy {
	
	private static Queue<Batch> batches = new LinkedList<Batch>();
	private int lastUsedDefaultSlot = 10;
	private int lastUsedSlot = lastUsedDefaultSlot;
	private int lastAttackedDefaultSlot = 0;
	private int lastAttackedSlot = lastAttackedDefaultSlot;
	AttackHelpPolicy helpPolicy = null;
	AttackHelpPolicy attackPolicy = null;
//	CallExpressionPolicy callAttack = null;
	PrintStream log = null;
	
	public YetAnotherStrategy(){
		helpPolicy = new AttackHelpPolicy(AttackHelpPolicy.TYPE.HELP, 7, lastUsedSlot++, 6, 5000);
		attackPolicy = new AttackHelpPolicy(AttackHelpPolicy.TYPE.ATTACK, 5, 6, lastAttackedSlot++, 4000);
//		callAttack = new CallExpressionPolicy(9, 5, 0, true);
		batches.addAll(helpPolicy.getBatches());
		batches.addAll(attackPolicy.getBatches());
//		batches.addAll(callAttack.getBatches());
		try {
			log = new PrintStream("strategy.log");
		} catch (IOException e) {
		}
	}

	@Override
	public Batch move(Player proponent, Player opponent) {
		if(opponent.getSlot(lastAttackedSlot-1).getVitality() <= 0){
			log.println("opponent slot " + (lastAttackedSlot-1) + " is dead");
			if(lastAttackedSlot > 254)
				lastAttackedSlot = lastAttackedDefaultSlot;
			batches.clear();
			attackPolicy = new AttackHelpPolicy(AttackHelpPolicy.TYPE.ATTACK, 5, 6, lastAttackedSlot++, 4000);
//			callAttack = new CallExpressionPolicy(9, 5, 0, true);
			batches.addAll(attackPolicy.getBatches());
//			batches.addAll(callAttack.getBatches());
		}
		if(!batches.isEmpty())
			return batches.poll();
		if(lastUsedSlot > 255)
			lastUsedSlot = lastUsedDefaultSlot;
		for(int i = 0; i <= 255; i++)
			if(opponent.getSlot(i).getVitality() != 10000)
				log.println("opponent slot " + (i) + " has " + opponent.getSlot(i).getVitality() + " vitality");
		for(int i = 0; i <= 255; i++)
			if(proponent.getSlot(i).getVitality() != 10000)
				log.println("proponent slot " + (i) + " has " + proponent.getSlot(i).getVitality() + " vitality");
		if(
				proponent.getSlot(6).getValue() instanceof Value && 
				opponent.getSlot(lastAttackedSlot - 1).getValue() instanceof Value && 
				((Value)proponent.getSlot(6).getValue()).getValue() * 1.1 < ((Value)opponent.getSlot(lastAttackedSlot - 1).getValue()).getValue()
				){
			helpPolicy = new AttackHelpPolicy(AttackHelpPolicy.TYPE.HELP, 7, lastUsedSlot++, 6, 5000);
			batches.addAll(helpPolicy.getBatches());
		}
		attackPolicy = new AttackHelpPolicy(AttackHelpPolicy.TYPE.ATTACK, 5, 6, lastAttackedSlot-1, 4000);
		batches.addAll(attackPolicy.getBatches());
//		batches.addAll(callAttack.getBatches());
		return move(proponent, opponent);
	}

}
